diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/config-store/model/xml-config.cc ns-3.39/src/config-store/model/xml-config.cc
--- ns-3.38/src/config-store/model/xml-config.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/config-store/model/xml-config.cc	2023-07-05 14:23:47.741427200 -0700
@@ -132,7 +132,7 @@
             ns3::TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED;
             for (std::size_t i = 0; i < tid.GetAttributeN(); i++)
             {
-                struct TypeId::AttributeInformation tmp = tid.GetAttribute(i);
+                TypeId::AttributeInformation tmp = tid.GetAttribute(i);
                 if (tmp.name == name)
                 {
                     supportLevel = tmp.supportLevel;
@@ -145,8 +145,7 @@
                                                 << " was not saved because it is OBSOLETE");
                 return;
             }
-            else if ((supportLevel == TypeId::SupportLevel::DEPRECATED) &&
-                     (m_saveDeprecated == false))
+            else if (supportLevel == TypeId::SupportLevel::DEPRECATED && !m_saveDeprecated)
             {
                 NS_LOG_WARN("Global attribute " << m_typeid << "::" << name
                                                 << " was not saved because it is DEPRECATED");
@@ -212,7 +211,7 @@
             ns3::TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED;
             for (std::size_t i = 0; i < tid.GetAttributeN(); i++)
             {
-                struct TypeId::AttributeInformation tmp = tid.GetAttribute(i);
+                TypeId::AttributeInformation tmp = tid.GetAttribute(i);
                 if (tmp.name == name)
                 {
                     supportLevel = tmp.supportLevel;
@@ -225,8 +224,7 @@
                                          << " was not saved because it is OBSOLETE");
                 return;
             }
-            else if ((supportLevel == TypeId::SupportLevel::DEPRECATED) &&
-                     (m_saveDeprecated == false))
+            else if (supportLevel == TypeId::SupportLevel::DEPRECATED && !m_saveDeprecated)
             {
                 NS_LOG_WARN("Attribute " << GetCurrentPath()
                                          << " was not saved because it is DEPRECATED");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/config-store/test/examples-to-run.py ns-3.39/src/config-store/test/examples-to-run.py
--- ns-3.38/src/config-store/test/examples-to-run.py	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/config-store/test/examples-to-run.py	2023-07-05 14:23:47.741427200 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/examples/command-line-example.cc ns-3.39/src/core/examples/command-line-example.cc
--- ns-3.38/src/core/examples/command-line-example.cc	2023-03-16 20:54:23.584868400 -0700
+++ ns-3.39/src/core/examples/command-line-example.cc	2023-07-05 14:23:47.741427200 -0700
@@ -101,7 +101,7 @@
     const TypeId tid = TypeId::LookupByName(attrClass);
     std::string attrDef;
     {
-        struct TypeId::AttributeInformation info;
+        TypeId::AttributeInformation info;
         tid.LookupAttributeByName(attrName, &info);
         attrDef = info.originalInitialValue->SerializeToString(info.checker);
     }
@@ -144,7 +144,7 @@
     // Look up new default value for attribute
     std::string antiArg;
     {
-        struct TypeId::AttributeInformation info;
+        TypeId::AttributeInformation info;
         tid.LookupAttributeByName(attrName, &info);
         antiArg = info.initialValue->SerializeToString(info.checker);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/examples/log-example.cc ns-3.39/src/core/examples/log-example.cc
--- ns-3.38/src/core/examples/log-example.cc	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/examples/log-example.cc	2023-07-05 14:23:47.745427100 -0700
@@ -51,9 +51,9 @@
 
     NS_LOG_ERROR("FreeEvent: error msg");
     NS_LOG_WARN("FreeEvent: warning msg");
-    NS_LOG_DEBUG("FreeEvent: debug msg");
     NS_LOG_INFO("FreeEvent: info msg");
     NS_LOG_LOGIC("FreeEvent: logic msg");
+    NS_LOG_DEBUG("FreeEvent: debug msg");
 }
 
 /** Simple object to aggregate to a node.
@@ -93,9 +93,9 @@
 
         NS_LOG_ERROR("MyEventObject:Event: error msg");
         NS_LOG_WARN("MyEventObject:Event: warning msg");
-        NS_LOG_DEBUG("MyEventObject:Event: debug msg");
         NS_LOG_INFO("MyEventObject:Event: info msg");
         NS_LOG_LOGIC("MyEventObject:Event: logic msg");
+        NS_LOG_DEBUG("MyEventObject:Event: debug msg");
     }
 
 }; // MyEventObject
@@ -110,26 +110,26 @@
     CommandLine cmd;
     cmd.Parse(argc, argv);
 
-    NS_LOG_UNCOND("Creating a Node");
+    NS_LOG_DEBUG("Creating a Node");
     auto node = CreateObject<Node>();
 
-    NS_LOG_UNCOND("Creating MyEventObject");
+    NS_LOG_DEBUG("Creating MyEventObject");
     auto myObj = CreateObject<MyEventObject>();
 
-    NS_LOG_UNCOND("Aggregating MyEventObject to Node");
+    NS_LOG_DEBUG("Aggregating MyEventObject to Node");
     node->AggregateObject(myObj);
 
-    NS_LOG_UNCOND("Scheduling the MyEventObject::Event with node context");
+    NS_LOG_INFO("Scheduling the MyEventObject::Event with node context");
     Simulator::ScheduleWithContext(node->GetId(), Seconds(3), &MyEventObject::Event, &(*myObj));
 
-    NS_LOG_UNCOND("Scheduling FreeEvent");
+    NS_LOG_INFO("Scheduling FreeEvent");
     Simulator::Schedule(Seconds(5), FreeEvent);
 
-    NS_LOG_UNCOND("Starting run...");
+    NS_LOG_DEBUG("Starting run...");
     Simulator::Run();
-    NS_LOG_UNCOND("... run complete");
+    NS_LOG_DEBUG("... run complete");
     Simulator::Destroy();
-    NS_LOG_UNCOND("Goodbye");
+    NS_LOG_DEBUG("Goodbye");
 
     return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/examples/sample-log-time-format.cc ns-3.39/src/core/examples/sample-log-time-format.cc
--- ns-3.38/src/core/examples/sample-log-time-format.cc	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/examples/sample-log-time-format.cc	2023-07-05 14:23:47.745427100 -0700
@@ -89,6 +89,8 @@
 #include "ns3/random-variable-stream.h"
 #include "ns3/simulator.h"
 
+#include <map>
+
 using namespace ns3;
 
 namespace
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/helper/csv-reader.cc ns-3.39/src/core/helper/csv-reader.cc
--- ns-3.38/src/core/helper/csv-reader.cc	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/helper/csv-reader.cc	2023-07-05 14:23:47.745427100 -0700
@@ -180,7 +180,7 @@
 
     std::istringstream tempStream(input);
 
-    std::int16_t tempOutput = 0;
+    int16_t tempOutput = 0;
     tempStream >> tempOutput;
 
     if (tempOutput >= std::numeric_limits<byte_type>::min() &&
@@ -247,7 +247,7 @@
 
     std::istringstream tempStream(input);
 
-    std::uint16_t tempOutput = 0;
+    uint16_t tempOutput = 0;
     tempStream >> tempOutput;
 
     if (tempOutput >= std::numeric_limits<byte_type>::min() &&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/helper/random-variable-stream-helper.h ns-3.39/src/core/helper/random-variable-stream-helper.h
--- ns-3.38/src/core/helper/random-variable-stream-helper.h	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/helper/random-variable-stream-helper.h	2023-07-05 14:23:47.745427100 -0700
@@ -18,6 +18,7 @@
 #ifndef RANDOM_VARIABLE_STREAM_HELPER_H
 #define RANDOM_VARIABLE_STREAM_HELPER_H
 
+#include <cstdint>
 #include <string>
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/attribute-accessor-helper.h ns-3.39/src/core/model/attribute-accessor-helper.h
--- ns-3.38/src/core/model/attribute-accessor-helper.h	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/attribute-accessor-helper.h	2023-07-05 14:23:47.749427000 -0700
@@ -247,7 +247,7 @@
 inline Ptr<const AttributeAccessor>
 DoMakeAccessorHelperOne(U T::*memberVariable)
 {
-    /* AttributeAcessor implementation for a class member variable. */
+    /* AttributeAccessor implementation for a class member variable. */
     class MemberVariable : public AccessorHelper<T, V>
     {
       public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/attribute-construction-list.cc ns-3.39/src/core/model/attribute-construction-list.cc
--- ns-3.38/src/core/model/attribute-construction-list.cc	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/attribute-construction-list.cc	2023-07-05 14:23:47.749427000 -0700
@@ -45,7 +45,7 @@
     // vector of values.
     NS_LOG_FUNCTION(this << name << checker << value);
 
-    for (std::list<struct Item>::iterator k = m_list.begin(); k != m_list.end(); k++)
+    for (std::list<Item>::iterator k = m_list.begin(); k != m_list.end(); k++)
     {
         if (k->checker == checker)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/attribute-construction-list.h ns-3.39/src/core/model/attribute-construction-list.h
--- ns-3.38/src/core/model/attribute-construction-list.h	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/attribute-construction-list.h	2023-07-05 14:23:47.749427000 -0700
@@ -50,8 +50,9 @@
         /** The name of the Attribute. */
         std::string name;
     };
+
     /** Iterator type. */
-    typedef std::list<struct Item>::const_iterator CIterator;
+    typedef std::list<Item>::const_iterator CIterator;
 
     /** Constructor */
     AttributeConstructionList();
@@ -81,7 +82,7 @@
 
   private:
     /** The list of Items */
-    std::list<struct Item> m_list;
+    std::list<Item> m_list;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/attribute-container.h ns-3.39/src/core/model/attribute-container.h
--- ns-3.38/src/core/model/attribute-container.h	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/attribute-container.h	2023-07-05 14:23:47.749427000 -0700
@@ -45,9 +45,10 @@
  * can return the items in a container specified by \p C.
  *
  * @tparam A AttributeValue type to be contained.
+ * @tparam Sep Character separator between elements for parsing.
  * @tparam C Possibly templated container class returned by Get.
  */
-template <class A, template <class...> class C = std::list>
+template <class A, char Sep = ',', template <class...> class C = std::list>
 class AttributeContainerValue : public AttributeValue
 {
   public:
@@ -74,9 +75,8 @@
 
     /**
      * Default constructor.
-     * \param[in] sep Character separator between elements for parsing.
      */
-    AttributeContainerValue(char sep = ',');
+    AttributeContainerValue();
 
     /**
      * Construct from another container.
@@ -186,9 +186,8 @@
      * \return This object with items copied.
      */
     template <class ITER>
-    Ptr<AttributeContainerValue<A, C>> CopyFrom(const ITER begin, const ITER end);
+    Ptr<AttributeContainerValue<A, Sep, C>> CopyFrom(const ITER begin, const ITER end);
 
-    char m_sep;                 //!< Item separator
     container_type m_container; //!< Internal container
 };
 
@@ -210,35 +209,40 @@
 /**
  * Make AttributeContainerChecker from AttributeContainerValue.
  * @tparam A \deduced AttributeValue type in container.
+ * @tparam Sep \deduced Character separator between elements for parsing.
  * @tparam C \deduced Container type returned by Get.
  * \param[in] value AttributeContainerValue from which to deduce types.
  * \return AttributeContainerChecker for value.
  */
-template <class A, template <class...> class C>
-Ptr<AttributeChecker> MakeAttributeContainerChecker(const AttributeContainerValue<A, C>& value);
+template <class A, char Sep, template <class...> class C>
+Ptr<AttributeChecker> MakeAttributeContainerChecker(
+    const AttributeContainerValue<A, Sep, C>& value);
 
 /**
  * Make AttributeContainerChecker using explicit types, initialize item checker.
  * @tparam A AttributeValue type in container.
+ * @tparam Sep Character separator between elements for parsing.
  * @tparam C Container type returned by Get.
  * \param[in] itemchecker AttributeChecker used for each item in the container.
  * \return AttributeContainerChecker.
  */
-template <class A, template <class...> class C = std::list>
+template <class A, char Sep = ',', template <class...> class C = std::list>
 Ptr<const AttributeChecker> MakeAttributeContainerChecker(Ptr<const AttributeChecker> itemchecker);
 
 /**
  * Make uninitialized AttributeContainerChecker using explicit types.
  * @tparam A AttributeValue type in container.
+ * @tparam Sep Character separator between elements for parsing.
  * @tparam C Container type returned by Get.
  * \return AttributeContainerChecker.
  */
-template <class A, template <class...> class C = std::list>
+template <class A, char Sep = ',', template <class...> class C = std::list>
 Ptr<AttributeChecker> MakeAttributeContainerChecker();
 
 /**
  * Make AttributeContainerAccessor  using explicit types.
  * @tparam A AttributeValue type in container.
+ * @tparam Sep Character separator between elements for parsing.
  * @tparam C Container type returned by Get.
  * \tparam T1 \deduced The type of the class data member,
  *            or the type of the class get functor or set method.
@@ -246,12 +250,13 @@
  *            or the get or set method.
  * \return AttributeContainerAccessor.
  */
-template <typename A, template <typename...> class C = std::list, typename T1>
+template <typename A, char Sep = ',', template <typename...> class C = std::list, typename T1>
 Ptr<const AttributeAccessor> MakeAttributeContainerAccessor(T1 a1);
 
 /**
  * Make AttributeContainerAccessor  using explicit types.
  * @tparam A AttributeValue type in container.
+ * @tparam Sep Character separator between elements for parsing.
  * @tparam C Container type returned by Get.
  * \tparam T1 \deduced The type of the class data member,
  *            or the type of the class get functor or set method.
@@ -262,7 +267,11 @@
  *            or the get or set method.
  * \return AttributeContainerAccessor.
  */
-template <typename A, template <typename...> class C = std::list, typename T1, typename T2>
+template <typename A,
+          char Sep = ',',
+          template <typename...> class C = std::list,
+          typename T1,
+          typename T2>
 Ptr<const AttributeAccessor> MakeAttributeContainerAccessor(T1 a1, T2 a2);
 
 } // namespace ns3
@@ -283,7 +292,7 @@
  * in MakeAttributeContainerChecker. The non-templated base ns3::AttributeContainerChecker
  * is returned from that function. This is the same pattern as ObjectPtrContainer.
  */
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 class AttributeContainerChecker : public ns3::AttributeContainerChecker
 {
   public:
@@ -300,58 +309,59 @@
     Ptr<const AttributeChecker> m_itemchecker; //!< The AttributeChecker
 };
 
-template <class A, template <class...> class C>
-AttributeContainerChecker<A, C>::AttributeContainerChecker()
+template <class A, char Sep, template <class...> class C>
+AttributeContainerChecker<A, Sep, C>::AttributeContainerChecker()
     : m_itemchecker(nullptr)
 {
 }
 
-template <class A, template <class...> class C>
-AttributeContainerChecker<A, C>::AttributeContainerChecker(Ptr<const AttributeChecker> itemchecker)
+template <class A, char Sep, template <class...> class C>
+AttributeContainerChecker<A, Sep, C>::AttributeContainerChecker(
+    Ptr<const AttributeChecker> itemchecker)
     : m_itemchecker(itemchecker)
 {
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 void
-AttributeContainerChecker<A, C>::SetItemChecker(Ptr<const AttributeChecker> itemchecker)
+AttributeContainerChecker<A, Sep, C>::SetItemChecker(Ptr<const AttributeChecker> itemchecker)
 {
     m_itemchecker = itemchecker;
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 Ptr<const AttributeChecker>
-AttributeContainerChecker<A, C>::GetItemChecker() const
+AttributeContainerChecker<A, Sep, C>::GetItemChecker() const
 {
     return m_itemchecker;
 }
 
 } // namespace internal
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 Ptr<AttributeChecker>
-MakeAttributeContainerChecker(const AttributeContainerValue<A, C>& value)
+MakeAttributeContainerChecker(const AttributeContainerValue<A, Sep, C>& value)
 {
-    return MakeAttributeContainerChecker<A, C>();
+    return MakeAttributeContainerChecker<A, Sep, C>();
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 Ptr<const AttributeChecker>
 MakeAttributeContainerChecker(Ptr<const AttributeChecker> itemchecker)
 {
-    auto checker = MakeAttributeContainerChecker<A, C>();
+    auto checker = MakeAttributeContainerChecker<A, Sep, C>();
     auto acchecker = DynamicCast<AttributeContainerChecker>(checker);
     acchecker->SetItemChecker(itemchecker);
     return checker;
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 Ptr<AttributeChecker>
 MakeAttributeContainerChecker()
 {
     std::string containerType;
     std::string underlyingType;
-    typedef AttributeContainerValue<A, C> T;
+    typedef AttributeContainerValue<A, Sep, C> T;
     {
         std::ostringstream oss;
         oss << "ns3::AttributeContainerValue<" << typeid(typename T::attribute_type).name() << ", "
@@ -365,51 +375,50 @@
         underlyingType = oss.str();
     }
 
-    return MakeSimpleAttributeChecker<T, internal::AttributeContainerChecker<A, C>>(containerType,
-                                                                                    underlyingType);
+    return MakeSimpleAttributeChecker<T, internal::AttributeContainerChecker<A, Sep, C>>(
+        containerType,
+        underlyingType);
 }
 
-template <class A, template <class...> class C>
-AttributeContainerValue<A, C>::AttributeContainerValue(char sep)
-    : m_sep(sep)
+template <class A, char Sep, template <class...> class C>
+AttributeContainerValue<A, Sep, C>::AttributeContainerValue()
 {
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 template <class CONTAINER>
-AttributeContainerValue<A, C>::AttributeContainerValue(const CONTAINER& c)
-    : AttributeContainerValue<A, C>(c.begin(), c.end())
+AttributeContainerValue<A, Sep, C>::AttributeContainerValue(const CONTAINER& c)
+    : AttributeContainerValue<A, Sep, C>(c.begin(), c.end())
 {
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 template <class ITER>
-AttributeContainerValue<A, C>::AttributeContainerValue(const ITER begin, const ITER end)
+AttributeContainerValue<A, Sep, C>::AttributeContainerValue(const ITER begin, const ITER end)
     : AttributeContainerValue()
 {
     CopyFrom(begin, end);
 }
 
-template <class A, template <class...> class C>
-AttributeContainerValue<A, C>::~AttributeContainerValue()
+template <class A, char Sep, template <class...> class C>
+AttributeContainerValue<A, Sep, C>::~AttributeContainerValue()
 {
     m_container.clear();
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 Ptr<AttributeValue>
-AttributeContainerValue<A, C>::Copy() const
+AttributeContainerValue<A, Sep, C>::Copy() const
 {
-    auto c = Create<AttributeContainerValue<A, C>>();
-    c->m_sep = m_sep;
+    auto c = Create<AttributeContainerValue<A, Sep, C>>();
     c->m_container = m_container;
     return c;
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 bool
-AttributeContainerValue<A, C>::DeserializeFromString(std::string value,
-                                                     Ptr<const AttributeChecker> checker)
+AttributeContainerValue<A, Sep, C>::DeserializeFromString(std::string value,
+                                                          Ptr<const AttributeChecker> checker)
 {
     auto acchecker = DynamicCast<const AttributeContainerChecker>(checker);
     if (!acchecker)
@@ -418,7 +427,7 @@
     }
 
     std::istringstream iss(value); // copies value
-    while (std::getline(iss, value, m_sep))
+    while (std::getline(iss, value, Sep))
     {
         auto avalue = acchecker->GetItemChecker()->CreateValidValue(StringValue(value));
         if (!avalue)
@@ -438,9 +447,9 @@
     return true;
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 std::string
-AttributeContainerValue<A, C>::SerializeToString(Ptr<const AttributeChecker> checker) const
+AttributeContainerValue<A, Sep, C>::SerializeToString(Ptr<const AttributeChecker> checker) const
 {
     std::ostringstream oss;
     bool first = true;
@@ -448,7 +457,7 @@
     {
         if (!first)
         {
-            oss << m_sep;
+            oss << Sep;
         }
         oss << attr->SerializeToString(checker);
         first = false;
@@ -456,9 +465,9 @@
     return oss.str();
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::result_type
-AttributeContainerValue<A, C>::Get() const
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::result_type
+AttributeContainerValue<A, Sep, C>::Get() const
 {
     result_type c;
     for (const value_type& a : *this)
@@ -468,10 +477,10 @@
     return c;
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 template <typename T>
 bool
-AttributeContainerValue<A, C>::GetAccessor(T& value) const
+AttributeContainerValue<A, Sep, C>::GetAccessor(T& value) const
 {
     result_type src = Get();
     value.clear();
@@ -479,75 +488,75 @@
     return true;
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 template <class T>
 void
-AttributeContainerValue<A, C>::Set(const T& c)
+AttributeContainerValue<A, Sep, C>::Set(const T& c)
 {
     m_container.clear();
     CopyFrom(c.begin(), c.end());
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::size_type
-AttributeContainerValue<A, C>::GetN() const
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::size_type
+AttributeContainerValue<A, Sep, C>::GetN() const
 {
     return size();
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::Iterator
-AttributeContainerValue<A, C>::Begin()
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::Iterator
+AttributeContainerValue<A, Sep, C>::Begin()
 {
     return begin();
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::Iterator
-AttributeContainerValue<A, C>::End()
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::Iterator
+AttributeContainerValue<A, Sep, C>::End()
 {
     return end();
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::size_type
-AttributeContainerValue<A, C>::size() const
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::size_type
+AttributeContainerValue<A, Sep, C>::size() const
 {
     return m_container.size();
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::iterator
-AttributeContainerValue<A, C>::begin()
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::iterator
+AttributeContainerValue<A, Sep, C>::begin()
 {
     return m_container.begin();
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::iterator
-AttributeContainerValue<A, C>::end()
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::iterator
+AttributeContainerValue<A, Sep, C>::end()
 {
     return m_container.end();
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::const_iterator
-AttributeContainerValue<A, C>::begin() const
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::const_iterator
+AttributeContainerValue<A, Sep, C>::begin() const
 {
     return m_container.cbegin();
 }
 
-template <class A, template <class...> class C>
-typename AttributeContainerValue<A, C>::const_iterator
-AttributeContainerValue<A, C>::end() const
+template <class A, char Sep, template <class...> class C>
+typename AttributeContainerValue<A, Sep, C>::const_iterator
+AttributeContainerValue<A, Sep, C>::end() const
 {
     return m_container.cend();
 }
 
-template <class A, template <class...> class C>
+template <class A, char Sep, template <class...> class C>
 template <class ITER>
-Ptr<AttributeContainerValue<A, C>>
-AttributeContainerValue<A, C>::CopyFrom(const ITER begin, const ITER end)
+Ptr<AttributeContainerValue<A, Sep, C>>
+AttributeContainerValue<A, Sep, C>::CopyFrom(const ITER begin, const ITER end)
 {
     for (ITER iter = begin; iter != end; ++iter)
     {
@@ -556,18 +565,18 @@
     return this;
 }
 
-template <typename A, template <typename...> class C, typename T1>
+template <typename A, char Sep, template <typename...> class C, typename T1>
 Ptr<const AttributeAccessor>
 MakeAttributeContainerAccessor(T1 a1)
 {
-    return MakeAccessorHelper<AttributeContainerValue<A, C>>(a1);
+    return MakeAccessorHelper<AttributeContainerValue<A, Sep, C>>(a1);
 }
 
-template <typename A, template <typename...> class C, typename T1, typename T2>
+template <typename A, char Sep, template <typename...> class C, typename T1, typename T2>
 Ptr<const AttributeAccessor>
 MakeAttributeContainerAccessor(T1 a1, T2 a2)
 {
-    return MakeAccessorHelper<AttributeContainerValue<A, C>>(a1, a2);
+    return MakeAccessorHelper<AttributeContainerValue<A, Sep, C>>(a1, a2);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/callback.h ns-3.39/src/core/model/callback.h
--- ns-3.38/src/core/model/callback.h	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/callback.h	2023-07-05 14:23:47.749427000 -0700
@@ -184,12 +184,7 @@
         auto p = std::dynamic_pointer_cast<const CallbackComponent<T>>(other);
 
         // other must have the same type and value as ours
-        if (p == nullptr || p->m_comp != m_comp)
-        {
-            return false;
-        }
-
-        return true;
+        return !(p == nullptr || p->m_comp != m_comp);
     }
 
   private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/command-line.cc ns-3.39/src/core/model/command-line.cc
--- ns-3.38/src/core/model/command-line.cc	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/command-line.cc	2023-07-05 14:23:47.749427000 -0700
@@ -572,7 +572,7 @@
     {
         std::stringstream ss;
         ss << "    --" << tid.GetAttributeFullName(i) << "=[";
-        struct TypeId::AttributeInformation info = tid.GetAttribute(i);
+        TypeId::AttributeInformation info = tid.GetAttribute(i);
         ss << info.initialValue->SerializeToString(info.checker) << "]\n"
            << "        " << info.help << "\n";
         attributes.push_back(ss.str());
@@ -790,7 +790,7 @@
     }
 
     const std::string attrName = attributePath.substr(colon + 2);
-    struct TypeId::AttributeInformation info;
+    TypeId::AttributeInformation info;
     if (!tid.LookupAttributeByName(attrName, &info))
     {
         NS_FATAL_ERROR("Attribute not found: " << attributePath);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/config.cc ns-3.39/src/core/model/config.cc
--- ns-3.38/src/core/model/config.cc	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/config.cc	2023-07-05 14:23:47.753427000 -0700
@@ -542,7 +542,7 @@
 
             for (uint32_t i = 0; i < tid.GetAttributeN(); i++)
             {
-                struct TypeId::AttributeInformation info;
+                TypeId::AttributeInformation info;
                 info = tid.GetAttribute(i);
                 if (info.name != item && item != "*")
                 {
@@ -638,7 +638,7 @@
 {
   public:
     // Keep Set and SetFailSafe since their errors are triggered
-    // by the underlying ObjecBase functions.
+    // by the underlying ObjectBase functions.
     /** \copydoc ns3::Config::Set() */
     void Set(std::string path, const AttributeValue& value);
     /** \copydoc ns3::Config::SetFailSafe() */
@@ -862,7 +862,7 @@
         TypeId tid = TypeId::GetRegistered(i);
         for (uint32_t j = 0; j < tid.GetAttributeN(); j++)
         {
-            struct TypeId::AttributeInformation info = tid.GetAttribute(j);
+            TypeId::AttributeInformation info = tid.GetAttribute(j);
             tid.SetAttributeInitialValue(j, info.originalInitialValue);
         }
     }
@@ -914,11 +914,11 @@
     {
         return false;
     }
-    struct TypeId::AttributeInformation info;
+    TypeId::AttributeInformation info;
     tid.LookupAttributeByName(paramName, &info);
     for (uint32_t j = 0; j < tid.GetAttributeN(); j++)
     {
-        struct TypeId::AttributeInformation tmp = tid.GetAttribute(j);
+        TypeId::AttributeInformation tmp = tid.GetAttribute(j);
         if (tmp.name == paramName)
         {
             Ptr<AttributeValue> v = tmp.checker->CreateValidValue(value);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/default-simulator-impl.cc ns-3.39/src/core/model/default-simulator-impl.cc
--- ns-3.38/src/core/model/default-simulator-impl.cc	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/default-simulator-impl.cc	2023-07-05 14:23:47.753427000 -0700
@@ -375,16 +375,9 @@
         }
         return true;
     }
-    if (id.PeekEventImpl() == nullptr || id.GetTs() < m_currentTs ||
-        (id.GetTs() == m_currentTs && id.GetUid() <= m_currentUid) ||
-        id.PeekEventImpl()->IsCancelled())
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return id.PeekEventImpl() == nullptr || id.GetTs() < m_currentTs ||
+           (id.GetTs() == m_currentTs && id.GetUid() <= m_currentUid) ||
+           id.PeekEventImpl()->IsCancelled();
 }
 
 Time
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/core/model/default-simulator-impl.h ns-3.39/src/core/model/default-simulator-impl.h
--- ns-3.38/src/core/model/default-simulator-impl.h	2023-03-16 20:54:23.588868400 -0700
+++ ns-3.39/src/core/model/default-simulator-impl.h	2023-07-05 14:23:47.753427000 -0700
@@ -96,8 +96,9 @@
         /** The event implementation. */
         EventImpl* event;
     };
+
     /** Container type for the events from a different context. */
-    typedef std::list<struct EventWithContext> EventsWithContext;
+    typedef std::list<EventWithContext> EventsWithContext;
     /** The container of events from a different context. */
     EventsWithContext m_eventsWithContext;
     /**
